﻿package ru.zvzd3d.EKG.NikyEkgSD1;
// 21.08.2019 (Ср) - код с элементами управления
// 15.02.2019 (Чт) - код по чтению/заданию парам без cохр в eeprom. 

import java.io.IOException;
import java.lang.ref.WeakReference;
import java.nio.ByteBuffer;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Locale;
import java.util.UUID;

import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.preference.PreferenceManager;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.PendingIntent;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothServerSocket;
import android.bluetooth.BluetoothSocket;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.text.format.DateFormat;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnTouchListener;
import android.view.WindowManager;
import android.widget.LinearLayout;
import android.widget.Button;
//import android.widget.Spinner;
//import android.widget.ArrayAdapter;
import android.widget.SeekBar;
import android.widget.TextView;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbEndpoint;
import android.hardware.usb.UsbInterface;
import android.hardware.usb.UsbManager;
import android.hardware.usb.UsbRequest;

//import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.os.ParcelUuid;
//import java.util.List;
import java.util.Set;




@SuppressLint("DefaultLocale") 
public class MainActivity extends Activity implements OnClickListener, 
                                  SeekBar.OnSeekBarChangeListener, OnTouchListener
{
	private static final boolean IsDebugNoUsb = true;
	
	private TextView MyTx; 
	private TextView m_BumTx;  
	private TextView m_RcvTx;
	
	private UsbManager m_UsbMan = null;
	private UsbDevice m_UsbDev = null;
	private UsbDeviceConnection m_UsbConn = null;
	private UsbEndpoint m_UsbEP_Out = null;
	private UsbEndpoint m_UsbEP_In = null;
	
	private int m_ThreadsN = 0;   // число созданных рабочих потоков по приёму данных usb
	private int m_AllRd = 0;
	private int m_MaxRd = 0;
	private int m_AllOp = 0;
	private long m_Stat_OldT0 = 0;
	private int m_Stat_OldAllRd = 0;
	
	private ONikyGraph m_Graph = null; 
	
	private OEkgDataRcv m_YogaDrumsRcv = new OEkgDataRcv();  
	
	
	private Handler m_handler;
	 
	private PendingIntent m_UsbPermissionIntent;
	
	//private BluetoothSocket m_btSocket = null;
	private CHeatWriterThread m_HeatWriterThread;
	
    public int iiii = 0;
    
    private final String sHC05_UUID = "00001101-0000-1000-8000-00805F9B34FB";
    
    private int m_ChsN;
    private boolean m_IsNew115200;
    private boolean m_MyBTMode;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(this);	    
        boolean m_IsScreenOn = sp.getBoolean("m_IsScreenOn", true);
  	    if (m_IsScreenOn)
  	    {
  	      getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
  		  //else
  		  //getWindow().clearFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);  			  
  	    };
  	    
  	    String sChsN = sp.getString("ChsN", "2");
  	    m_ChsN = 2;
	    if (!sChsN.isEmpty()) m_ChsN = Integer.valueOf(sChsN);
	    if (m_ChsN < 1) m_ChsN = 1;
	    if (m_ChsN > 3) m_ChsN = 3;
	    
	    m_IsNew115200 = sp.getBoolean("m_IsNew115200", true);
	    
	    m_MyBTMode = sp.getBoolean("MyBTMode", true);  	    
      
  	    
		MyTx = (TextView) findViewById(R.id.IDC_MyTextView);
		MyTx.setText("Starting...\n");
		
		
		m_BumTx = (TextView) findViewById(R.id.IDC_BumTextView);
		m_BumTx.setText("Инфа: <будет тут>");
		
		m_RcvTx = (TextView) findViewById(R.id.IDC_RcvTextView);
		m_RcvTx.setText("Приём с com-порта: <тут>");
		
		m_Graph = (ONikyGraph) findViewById(R.id.IDC_NikyGraph1);
		m_Graph.MyTx = MyTx;
		m_Graph.m_ChsN = m_ChsN;
		m_Graph.m_IsUpdateGraph = sp.getBoolean("m_IsUpdateGraph", true);
		
		ShowDataBlockTx(); // для отладки визуализатора
		
		
        m_handler = new MyHandler(this);
        m_handler.sendEmptyMessage(10);
	    
	    View Button = findViewById(R.id.IDC_BUTTON_STOP);
        Button.setOnClickListener(this);
	    Button = findViewById(R.id.IDC_BUTTON_START);
        Button.setOnClickListener(this);
        
        
        findViewById(R.id.IDC_BUTTON_SAVEDATE).setOnClickListener(this);
        findViewById(R.id.IDC_BUTTON_AN0).setOnClickListener(this);
        findViewById(R.id.IDC_BUTTON_AN1).setOnClickListener(this);        
        findViewById(R.id.IDC_BUTTON_REFNO).setOnClickListener(this);
        findViewById(R.id.IDC_BUTTON_REF2).setOnClickListener(this);
        findViewById(R.id.IDC_BUTTON_REF1).setOnClickListener(this);
        findViewById(R.id.IDC_BUTTON_NAK).setOnClickListener(this);
        findViewById(R.id.IDC_BUTTON_NAKOFF).setOnClickListener(this);
        findViewById(R.id.IDC_BUTTON_BT2).setOnClickListener(this); 
        
        
        m_UsbPermissionIntent = PendingIntent.getBroadcast(this, 0, new Intent(MyACTION_USB_PERMISSION), 0);
		IntentFilter filter44 = new IntentFilter(MyACTION_USB_PERMISSION);
		registerReceiver(mUsbReceiver, filter44);
		
		m_YogaDrumsRcv.m_ChsN = m_ChsN;
		m_YogaDrumsRcv.Init(m_handler, m_Graph);
		
        m_UsbMan = (UsbManager)getSystemService(Context.USB_SERVICE);
        
        IntentFilter filter = new IntentFilter();
        filter.addAction(UsbManager.ACTION_USB_DEVICE_DETACHED);
        //filter.addAction(UsbManager.ACTION_USB_DEVICE_ATTACHED);
        registerReceiver(m_br, filter);
  		
	    Intent intent = getIntent();
	    String action = intent.getAction();
	    
	    if (UsbManager.ACTION_USB_DEVICE_ATTACHED.equals(action)) 
	    {
	      //если прога запущена на подключение устройства
		  MyTx.setText("StartApp ACTION_USB_DEVICE_ATTACHED\n");
	      UsbDevice device = (UsbDevice)intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);		    
	      if (device != null) UsbDevStart(device); else MyTx.setText("?? device == NULL! \n"); 
	    }
	    else
	    {
	      // обычный запуск приложения	
	      HashMap<String, UsbDevice> deviceList = m_UsbMan.getDeviceList();
          Iterator<UsbDevice> deviceIterator = deviceList.values().iterator();
          MyTx.setText("Usb Devices Count:" + deviceList.size() + "\n");
          UsbDevice device = null;
          while (deviceIterator.hasNext()) 
          {
             UsbDevice device2 = (UsbDevice) deviceIterator.next();
             MyTx.append("Device VID=" + device2.getVendorId() + " PID=" + device2.getProductId() + "\n");
             if (device == null && IsMyUsbDev(device2)) device = device2;
          };
          if (device != null)
          {
        	 MyTx.append("Пытаюсь работать с первым в списке Usb-Com \n");
         	 UsbDevStart(device);         	               
          }
          else
          {
        	MyTx.append("Нет подключенных Usb-Com! Поищем блютуз\n");
        	
        	EnumBT();  
        	
            if (m_AddButtonNum < 1)
            {
               m_BumTx.setText("Нет подключенных к usb и/или сопряженных блютуз-устройств!\nПодключите устройство, сопрягите и перезапустите это приложение");
               m_BumTx.setBackgroundColor(0xffffff00);
               m_AddBtnMac[0] = "3333";
               AddStartButton("3333");           	
            }
            else
            {
               m_BumTx.setText("Нажмите на блютуз-устройство для подключения к нему"); 
            };
          };
        	
	    };
	    
	};
	
	public void onResume() 
	{
	    super.onResume();
	};
	
	@Override
	protected void onPause() 
	{
		BT_Close();
		super.onPause();
	};
	
	private int m_AddButtonNum = 0; 
	
	private String m_AddBtnMac[] = new String[16];
	  
	
	private void AddStartButton(String Text)
	{
		LinearLayout ll = (LinearLayout)findViewById(R.id.IDC_SelectButtons2);

		LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(
	            LinearLayout.LayoutParams.MATCH_PARENT,
	            LinearLayout.LayoutParams.WRAP_CONTENT);
	    Button btn = new Button(this);
	    btn.setId(60000 + m_AddButtonNum++);
	    final int id_ = btn.getId();
	    btn.setText(Text);
	    //btn.setBackgroundColor(0xffff00ff);
	    ll.addView(btn, params);
	    btn.setOnClickListener(this);
	};
	
	private void EnumBT()
	{
  	    BluetoothAdapter bluetooth = BluetoothAdapter.getDefaultAdapter();
  	    if(bluetooth == null) 
        {
  		  MyTx.append("bluetooth отсутствует\n");
  		  return;
        };
  	    if (!bluetooth.isEnabled()) 
  	    {
  	      MyTx.append("bluetooth выключен\n");
  		  return;
  	    };
  	    
  	    String mydeviceaddress = bluetooth.getAddress();
  	    String mydevicename = bluetooth.getName();
  	    MyTx.append(mydevicename + " : " + mydeviceaddress + "\n");
  	    
  	    Set<BluetoothDevice> pairedDevices = bluetooth.getBondedDevices();
      
        if (pairedDevices == null)
        {
    	  MyTx.append("getBondedDevices вернула null\n");
  		  return;
        }
      
        //String sMyEKG_MAC = null;
        final String sHC05_UUID = "00001101-0000-1000-8000-00805F9B34FB";
        final UUID HC05_UUID = UUID.fromString(sHC05_UUID);
      
        if (pairedDevices.size() > 0) 
        {
          // проходимся в цикле по этому списку
          for (BluetoothDevice device : pairedDevices) 
          {
            MyTx.append(" Подкл name=" + device.getName() + ", adr=" + device.getAddress() + "\n");
            ParcelUuid[] uuids = device.getUuids(); 
            for (ParcelUuid uuid: uuids) 
            {
              MyTx.append("  uuid=" + uuid + "\n");
              if (uuid.getUuid().equals(HC05_UUID)) 
              {
            	MyTx.append("Нашел HC-06, ура!\n");
	            String EKG_MAC = device.getAddress();
	            if (m_AddButtonNum < 16)
	            {
	              m_AddBtnMac[m_AddButtonNum] = EKG_MAC;	          	  
	              AddStartButton(device.getName() + ", " + device.getAddress());            	
	            };
	            break;
              }
            };	          
          };
        };
    };
    
    private void BTOpenFromMAC(String sMyEKG_MAC) 
    {
    	BluetoothAdapter bluetooth = BluetoothAdapter.getDefaultAdapter();
  	    if(bluetooth == null) 
        {
  		  MyTx.append("bluetooth отсутствует\n");
  		  return;
        };
  	    if (!bluetooth.isEnabled()) 
  	    {
  	      MyTx.append("bluetooth выключен\n");
  		  return;
  	    };
  	    
    	BluetoothDevice device = null;
		try 
		{
		    device = bluetooth.getRemoteDevice(sMyEKG_MAC);
		}
		catch (Exception e) 
		{
		   MyTx.append("ERR getRemoteDevice " + e.getMessage() + "\n");
		   return;
		};
			
		if (device == null)
		{
		  MyTx.append("ERR getRemoteDevice вернула null \n");
		  return;
		};

		BluetoothSocket btSocket = null;
		try 
		{
		  final UUID HC05_UUID = UUID.fromString(sHC05_UUID);		      
		  btSocket = device.createRfcommSocketToServiceRecord(HC05_UUID);
		} 
		catch (Exception e) 
		{
		  MyTx.append("ERR createRfcommSocketToServiceRecord " + e.getMessage() + "\n");
		  return;
		};
		  
		MyTx.append("Ура! Открыт сокет ! Будем пробовать подключиться \n");
		  
		m_HeatWriterThread = new CHeatWriterThread(btSocket, m_handler, m_YogaDrumsRcv);
		m_HeatWriterThread.m_MyBTMode = m_MyBTMode ? 1 : 0;
		if (m_HeatWriterThread.m_MyBTMode==1) 
		{
			m_Graph.m_ChsN = 1;
			if (m_Graph.m_ShowN>=2000) m_Graph.m_ShowN /= 10;
		}
		m_HeatWriterThread.start();
    };
    
    
    void BT_Close()
    {
        if (m_HeatWriterThread != null)
	    {
           final byte Cmd[] = { (byte)0xcd, 0x58 };  // прекратить посыл данных BT
  		   PortWriteCmd(Cmd);
  		  
           MyTx.setText("BT closing... \n");
	       
	       m_HeatWriterThread.ExternStop();
	       try 
		   {
			 m_HeatWriterThread.join();
		   } 
		   catch (InterruptedException e) 
		   {	  		 	
		   };
		   m_HeatWriterThread = null;

		   MyTx.setText("BT is closed \n");
		   
		   findViewById(R.id.IDC_SelectButtons2).setVisibility(View.VISIBLE);
	    };        
    };
      
     
	
	private void SetDlgItemText(int ID, String Text)
	{
	  TextView Tx = (TextView) findViewById(ID);
	  if (Tx != null) Tx.setText(Text);		  
	};
	
		
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) 
	{
		MenuItem mi = menu.add(0, 1, 0, "Настройки");
		mi.setIntent(new Intent(this, PrefActivity.class));
		MenuItem mi2 = menu.add(0, 2, 0, "Дом. страница");
		Intent intent2 = new Intent(Intent.ACTION_VIEW);
		intent2.setData(Uri.parse("http://zvzd3d.ru/EKG/"));		
		mi2.setIntent(intent2);
		return super.onCreateOptionsMenu(menu);
		//// Inflate the menu; this adds items to the action bar if it is present.
		//getMenuInflater().inflate(R.menu.main, menu);
		//return true;
	}
	
	
	@Override
	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser)
	{
	}
	@Override
	public void onStartTrackingTouch(SeekBar seekBar)
	{		
	}
	@Override
	public void onStopTrackingTouch(SeekBar seekBar)
	{
	};
	
	private static final String MyACTION_USB_PERMISSION = "ru.zvzd3d.EKG.NikyEkgSD1.USB_PERMISSION";
	
	private final BroadcastReceiver mUsbReceiver = new BroadcastReceiver()
	{
	    public void onReceive(Context context, Intent intent)
	    {
	        String action = intent.getAction();
	        if (MyACTION_USB_PERMISSION.equals(action))
	        {
	            synchronized (this)
	            {
	                UsbDevice device = (UsbDevice)intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);
	 
	                if (intent.getBooleanExtra(UsbManager.EXTRA_PERMISSION_GRANTED, false))
	                {
	                    if(device != null)
	                    {
	                    	MyTx.append("Разрешение получено! \n");
	                    	UsbDevStartContinue(device);
	                    	return;
	                    }
	                    else MyTx.append("Разрешение получено, но device == null ! \n");
	                } 
	                else
	                {
	                	MyTx.append("Доступ отвергнут! \n");
	                }
	            }
	        }
	    }
	};		
	
	protected void UsbDevStart(UsbDevice device)
	{
	  m_UsbDev = null;
	  //if (m_UsbConn != null) m_UsbConn.close(); 
	  m_UsbConn = null;
	  m_UsbEP_Out = null;
	  m_UsbEP_In = null;
	  
	  if (device == null)  // вызывается так, если detach 
	  {
		MyTx.append("Closed usb device. \n");
	    return;
      };
      
      m_UsbConn = null;
	  if (!m_UsbMan.hasPermission(device)) 
	  {
		MyTx.append("Пока нет прав на usb, спросим\n");		
		m_UsbMan.requestPermission(device, m_UsbPermissionIntent);		
		return;
	  };
	  
	  UsbDevStartContinue(device);
	};
	
	protected void UsbDevStartContinue(UsbDevice device)
	{
		  
	  m_UsbConn = m_UsbMan.openDevice(device);
	  
	  UsbInterface intf = device.getInterface(0);
	  
	  if (intf != null && m_UsbConn != null && m_UsbConn.claimInterface(intf, true)) 
	  {
		MyTx.append("open usb device SUCCESS! \n");
		String ss = m_UsbConn.getSerial();
		MyTx.append("Serial: " + ss + " \n");		
		MyTx.append("EndpointCount: " + intf.getEndpointCount() + " \n");		
		//m_UsbEP1_Out = intf.getEndpoint(1);
		//m_UsbEP1_In = intf.getEndpoint(0);
		//m_UsbDev = device;
		//LoadParamsFromDev();
		
		//m_UsbEP2_In = intf.getEndpoint(2);
		
		m_YogaDrumsRcv.m_SkipN = 0; 
		
		int Speed = 115200 / 2;
		if (m_IsNew115200) Speed = 115200;
		
		if (OUsbComPL203.IsMyDevice(device))
		{
		  MyTx.append("Опознана PL2303!!! \n");
		  OUsbComPL203 PL2303 = new OUsbComPL203();			
		  String serr = PL2303.Init(m_UsbConn, intf,  Speed);
		  if (serr.length() > 0)
		  {
			MyTx.append(serr + "\n");
		  }
		  else
		  {
			MyTx.append("PL2303 успешно инициализирована, ура! \n");
			if (PL2303.FindDataEPs(intf))
			{
			  m_UsbEP_In = PL2303.m_EP_In;    PL2303.m_EP_In = null;
			  m_UsbEP_Out = PL2303.m_EP_Out;  PL2303.m_EP_Out = null;
			}
			else
			{
			  MyTx.append("Ошибка, не нашлось EP данных! \n");					
			};
		  };
		}
		else
		if (OUsbComCP2102.IsMyDevice(device))
		{
		  MyTx.append("Опознана CP2102!!! \n");
		  OUsbComCP2102 CP2102 = new OUsbComCP2102();			
		  String serr = CP2102.Init(m_UsbConn, intf,  Speed);
		  if (serr.length() > 0)
		  {
			MyTx.append(serr + "\n");
		  }
		  else
		  {
			MyTx.append("CP2102 успешно инициализирована, ура! \n");
			if (CP2102.FindDataEPs(intf))
			{
			  m_UsbEP_In = CP2102.m_EP_In;    CP2102.m_EP_In = null;
			  m_UsbEP_Out = CP2102.m_EP_Out;  CP2102.m_EP_Out = null;
			}
			else
			{
			  MyTx.append("Ошибка, не нашлось EP данных! \n");					
			};
		  };
		}
		else
		if (OUsbComCH340.IsMyDevice(device))
		{
		  MyTx.append("Опознана CH340!!! \n");
		  OUsbComCH340 CH340 = new OUsbComCH340();			
		  String serr = CH340.Init(m_UsbConn, intf,  Speed);
		  if (serr.length() > 0)
		  {
			MyTx.append(serr + "\n");
		  }
		  else
		  {
			MyTx.append("CH340 успешно инициализирована, ура! \n");
			if (CH340.FindDataEPs(intf))
			{
			  m_UsbEP_In = CH340.m_EP_In;    CH340.m_EP_In = null;
			  m_UsbEP_Out = CH340.m_EP_Out;  CH340.m_EP_Out = null;
			}
			else
			{
			  MyTx.append("Ошибка, не нашлось EP данных! \n");					
			};
		  };
		}		
		else
		{
		  MyTx.append("Устройство usb-com мной не опознано, увы!!! \n");
		};
		
		if (m_UsbEP_In != null)
		{
		  Thread thr = new Thread(m_Run);
		  thr.setDaemon(true);
		  thr.start();
		};
	  }
	  else
	  {  
		MyTx.append("Open usb device ERROR ! \n");
		m_UsbDev = null;
		//if (m_UsbConn != null) m_UsbConn.close(); 
		m_UsbConn = null;  
		m_UsbEP_Out = null;
		m_UsbEP_In = null;		
      };
	};
	
	private BroadcastReceiver m_br = new BroadcastReceiver() 
    {
      // действия при получении сообщений
      public void onReceive(Context context, Intent intent) 
      {
        if (intent.getAction().equals(UsbManager.ACTION_USB_DEVICE_DETACHED))
        {
          MyTx.append("USB_DEVICE_DETACHED!\n");
          UsbDevice device = (UsbDevice)intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);  	    
          if (m_UsbDev != null && m_UsbDev.equals(device)) 
	      {
	        UsbDevStart(null);
	        MyTx.append("Устройство usb отключено!\n");
	        //finish();
	      };
        };
        if (intent.getAction().equals(UsbManager.ACTION_USB_DEVICE_ATTACHED))
        {
          MyTx.append("USB_DEVICE_ATTACHED!\n");
          UsbDevice device = (UsbDevice)intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);  	    
          if (m_UsbDev == null && device != null && IsMyUsbDev(device))
          {
        	UsbDevStart(device);  	          
          };
        };
      };
    };
    
    public static boolean IsMyUsbDev(UsbDevice device)
    {
      if (OUsbComPL203.IsMyDevice(device)) return true;
      if (OUsbComCP2102.IsMyDevice(device)) return true;
      if (OUsbComCH340.IsMyDevice(device)) return true;      
      return false;
    };
		

    public void onClick(View v) 
	{
  	  MyTx.append(" Click " + v.getId() + "\n");
  	  if (v.getId() >= 60000 && v.getId()<60100)
  	  {
  		int btind = v.getId() - 60000; 
  		MyTx.setText("Открываю BT " + m_AddBtnMac[btind] + "\n");
  		BT_Close();
  		BTOpenFromMAC(m_AddBtnMac[btind]);
  		return;		    
  	  };
	  switch (v.getId()) 
	  {
	    case R.id.IDC_BUTTON_START:
		{
		  MyTx.setText("Перезапуск кардиографа для начала записи\n"); 
		  final byte Cmd[] = { (byte)0xcd, 10 };  // Начать отображение и запись ЭКГ
		  //final byte Cmd[] = { (byte)0xcd, 0x57 };  
		  boolean Is = PortWriteCmd(Cmd);
		  if (!Is) return;
		  break;
		}
	    case R.id.IDC_BUTTON_STOP:
		{
		  MyTx.setText("Остановка записи, переход на внешнее управление\n"); 
		  final byte Cmd[] = { (byte)0xcd, 11 };
		  //final byte Cmd[] = { (byte)0xcd, 0x58 };
		  boolean Is = PortWriteCmd(Cmd);
		  if (!Is) return;
		  break;
		}
	    case R.id.IDC_BUTTON_SAVEDATE:
		{
		  MyTx.setText("Сохраняю в базу дату и время начала записи текущего файла\n");
		  if (m_HeatWriterThread != null)
		  {
			  MyTx.setText("Отключаюсь от блютуза\n");
			  BT_Close();
			  return;
		  };		  
		  
		  String OldDate = FileDateCache(null);
		  String strdate = m_YogaDrumsRcv.GetStartDate();
		  FileDateCache(strdate);
		  
		  MyTx.append(OldDate + " было \n");
		  MyTx.append(strdate + " стало \n");
		  break;
		}
		
	 	case R.id.IDC_BUTTON_AN0:
		{
  	      MyTx.setText("Выбрать аналоговый вход AN0 (удобно, если доп. усилитель перегружается)\n"); 
	      final byte Cmd[] = { (byte)0xcd, 0x50 }; 
		  boolean Is = PortWriteCmd(Cmd);
		  if (!Is) return;
		  break;
		}
	 	case R.id.IDC_BUTTON_AN1:
		{
  	      MyTx.setText("Выбрать аналоговый вход AN1\n"); 
	      final byte Cmd[] = { (byte)0xcd, 0x51 }; 
		  boolean Is = PortWriteCmd(Cmd);
		  if (!Is) return;
		  break;
		}
	 	case R.id.IDC_BUTTON_REFNO:
		{
	  	      MyTx.setText("Работа АЦП МК без внешних опорных напряжений \n"); 
		      final byte Cmd[] = { (byte)0xcd, 0x52 }; 
			  boolean Is = PortWriteCmd(Cmd);
			  if (!Is) return;
			  break;
		}
	 	case R.id.IDC_BUTTON_REF2:
		{
	  	      MyTx.setText("Работа АЦП МК с внешними опорными напряжениями на AN3+ и AN2-\n"); 
		      final byte Cmd[] = { (byte)0xcd, 0x53 }; 
			  boolean Is = PortWriteCmd(Cmd);
			  if (!Is) return;
			  break;
		}
	 	case R.id.IDC_BUTTON_REF1:
		{
	  	      MyTx.setText("Работа АЦП МК с внешним опорным напряжением только на AN3+\n"); 
		      final byte Cmd[] = { (byte)0xcd, 0x54 }; 
			  boolean Is = PortWriteCmd(Cmd);
			  if (!Is) return;
			  break;
		}
	 	case R.id.IDC_BUTTON_NAK:
		{
	  	      m_YogaDrumsRcv.m_MustSkipBTOneByte = true;
			  MyTx.setText("Режим накопления серии выборок АЦП для одной выборки ЭКГ\n"); 
		      final byte Cmd[] = { (byte)0xcd, 0x55 }; 
			  boolean Is = PortWriteCmd(Cmd);
			  if (!Is) return;
			  break;
		}
	 	case R.id.IDC_BUTTON_NAKOFF:
		{
			  m_YogaDrumsRcv.m_MustSkipBTOneByte = true;
			  MyTx.setText("Выключено накопление серии выборок АЦП\n"); 
		      final byte Cmd[] = { (byte)0xcd, 0x56 }; 
			  boolean Is = PortWriteCmd(Cmd);
			  if (!Is) return;
			  break;
		}
	 	case R.id.IDC_BUTTON_BT2:
		{
	  	    if (m_HeatWriterThread != null)
	  	    {
	  	       MyTx.setText("BT test close \n");
	  	       m_HeatWriterThread.ExternStop();
	  	       try 
	  		   {
	  			 m_HeatWriterThread.join();
	  		   } 
	  		   catch (InterruptedException e) 
	  		   {	  		 	
	  		   };
	  		   m_HeatWriterThread = null;

	  	       return;
	  	    }
	  	    
	  	    MyTx.setText("BT test\n");
	  	    
	  	    BluetoothAdapter bluetooth = BluetoothAdapter.getDefaultAdapter();
	  	    if(bluetooth == null) 
	        {
	  		  MyTx.append("bluetooth отсутствует\n");
	  		  return;
	        };
	  	    if (!bluetooth.isEnabled()) 
	  	    {
	  	      MyTx.append("bluetooth выключен\n");
	  		  return;
	  	    };
	  	    
	  	    
	  	  String mydeviceaddress = bluetooth.getAddress();
	      String mydevicename = bluetooth.getName();
	      MyTx.append(mydevicename + " : " + mydeviceaddress + "\n");
	        
	      Set<BluetoothDevice> pairedDevices = bluetooth.getBondedDevices();
	      
	      if (pairedDevices == null)
	      {
	    	  MyTx.append("getBondedDevices вернула null\n");
	  		  return;
	      }
	      
	      String sMyEKG_MAC = null;
	      final UUID HC05_UUID = UUID.fromString(sHC05_UUID);
	      
	      if (pairedDevices.size() > 0) 
	      {
	        // проходимся в цикле по этому списку
	        for (BluetoothDevice device : pairedDevices) 
	        {
	          MyTx.append(" Подкл name=" + device.getName() + ", adr=" + device.getAddress() + "\n");
	          ParcelUuid[] uuids = device.getUuids(); 
	          for (ParcelUuid uuid: uuids) 
	          {
	            MyTx.append("  uuid=" + uuid + "\n");
	            if (uuid.getUuid().equals(HC05_UUID)) 
	            {
	            	MyTx.append("нашел!\n");
		            sMyEKG_MAC = device.getAddress(); 
	            }
	          };	          
	        };
	      };
	      
	      if (sMyEKG_MAC == null)
	      {
	    	 MyTx.append("Не нашел устройств для работы !\n");
	    	 return;	              
	      };
	      
	      MyTx.append("НАШЕЛ mac=" + sMyEKG_MAC + "\n");
	    	
	      BluetoothDevice device = null;
		  try 
		  {
		    device = bluetooth.getRemoteDevice(sMyEKG_MAC);
		  }
		  catch (Exception e) 
		  {
			MyTx.append("ERR getRemoteDevice " + e.getMessage() + "\n");
			return;
		  };
			
		  if (device == null)
		  {
			MyTx.append("ERR getRemoteDevice вернула null \n");
		    return;
		  };

		  BluetoothSocket btSocket = null;
		  try 
		  {
			btSocket = device.createRfcommSocketToServiceRecord(HC05_UUID);
		  } 
		  catch (Exception e) 
		  {
			MyTx.append("ERR createRfcommSocketToServiceRecord " + e.getMessage() + "\n");
			return;
		  };
		  
		  MyTx.append("Ура! Открыт сокет ! Будем пробовать подключиться \n");
		  
		  m_HeatWriterThread = new CHeatWriterThread(btSocket, m_handler, m_YogaDrumsRcv);
		  m_HeatWriterThread.m_MyBTMode = 0;
		  m_HeatWriterThread.start();
  
	  	  return;
	    }
	 }  
	 
	}
	
	private boolean PortWriteCmd(byte Cmd[])
	{
	  if (m_HeatWriterThread != null)
	  {
		  //String s = "Rcv " + m_HeatWriterThread.m_RcvBytes + " за " + m_HeatWriterThread.m_RcvCount;
		  //m_RcvTx.setText(s);
		  boolean Is = m_HeatWriterThread.SendMy(Cmd);
		  if (!Is) MyTx.append(" SendBT err !!!\n");
		  return Is;
	  };
	  
	  if (m_UsbConn == null || m_UsbEP_Out == null) 
	  {
		if (IsDebugNoUsb) return true;
		MyTx.append("\nPortWrite err: no open usb");
		return false;
	  };
	  int nsnd = m_UsbConn.bulkTransfer(m_UsbEP_Out, Cmd, Cmd.length, 1000);
	  if (nsnd<0 || nsnd != Cmd.length)
	  {
		MyTx.append("\nPortWrite err, nsnd = " + nsnd);
		return false;
	  };	  
	  try 
  	  {
  		Thread.sleep(5);
  	  } 
  	  catch (InterruptedException e1) 
  	  { 
  		MyTx.append("\nPortWrite Interrupted " + e1);		
  	  };
  	  return true;
	};
	
	
	

	
	

	
	@Override
	protected void onDestroy() 
	{
	  m_handler.removeCallbacksAndMessages(null);
	  m_handler = null;
	  super.onDestroy();	  
	};

	
	
	static class MyHandler extends Handler 
	{
	  private WeakReference<MainActivity> wrActivity;
      public MyHandler(MainActivity activity) 
      {
        wrActivity = new WeakReference<MainActivity>(activity);
      };

      @Override
      public void handleMessage(Message msg) 
      {
        super.handleMessage(msg);
        MainActivity activity = wrActivity.get();
        if (activity != null) activity.NotyFromHandler(msg);
      };
    };
    
    public void NotyFromHandler(Message msg)
	{
      if (msg.what == 33)  
      {
    	MyTx.append("Устройство блютуз подключено!\n");
    	findViewById(R.id.IDC_SelectButtons2).setVisibility(View.GONE);
    	final byte Cmd[] = { (byte)0xcd, 0x57 };  // разрешить посыл данных
    	PortWriteCmd(Cmd);
    	return;   	
      };
      if (msg.what == 111) 
      {
    	MyTx.append("Поток приёма от блютуз завершен " + msg.obj + "\n");
    	return;   	
      };
      
      
      if (msg.what == 777)  // график обновлен 
      {
    	//m_YogaDrumsRcv.ProcessEKGBlock(); // обработаем принятый блок данных - извлечем выборки сигнала и прочее
    	m_Graph.AnalizeSignal();
    	m_Graph.invalidate();
    	
    	ShowDataBlockTx();
    	 
    	m_handler.removeMessages(777);
        return;    	
      };

      if (msg.what == 778)  // график обновлен, другое нет  
      {
    	m_Graph.AnalizeSignal();
    	m_Graph.invalidate();    	
    	//ShowDataBlockTx();    	 
    	m_handler.removeMessages(778);
        return;    	
      };
      
      if (msg.what == 10)  // периодический опрос по таймеру (статистика приёма от usb)
      {
        m_handler.removeMessages(10);
        m_handler.sendEmptyMessageDelayed(10, 300);
        
        if (m_HeatWriterThread != null)
  	    {
  		  String s = "i=" + iiii + " BT_Rcv " + m_HeatWriterThread.m_RcvBytes + " за " + m_HeatWriterThread.m_RcvCount; iiii++;
  		  m_RcvTx.setText(s);
  		  return;
  	    };
        
        int AllRd = m_AllRd;
        long time = System.nanoTime();
        double Speed = (AllRd-m_Stat_OldAllRd) * 1.0e9 / (time-m_Stat_OldT0); 
        m_Stat_OldT0 = time;
    	m_Stat_OldAllRd = AllRd;
    	
    	int MaxRd = m_MaxRd; m_MaxRd = 0;
    	
    	String s;
    	if (m_ThreadsN == 1) s = String.format("%.0f байт/с, блок %d",  Speed, MaxRd);
    	else
    	if (m_ThreadsN == 0) s = String.format("Нет приёма %.0f б/с, бл %d",  Speed, MaxRd);
    	else s = String.format("Потоки %.0f байт/с, блок %d",  Speed, MaxRd);
    	
    	s += ", skip=" +  m_YogaDrumsRcv.m_SkipN;
    	
    	m_RcvTx.setText(s);
    	return;
      };
      
      
	};
	
	private void ShowDataBlockTx()
	{
	  Locale locale = Locale.getDefault();
		 
	  String Tx = "";
	  if ((m_YogaDrumsRcv.MMC_Init_Status & (1<<MMCINIT_CANWRITE)) != 0)
  	  {
	    Tx += "ЗАПИСЬ на SD";
	    if ((m_YogaDrumsRcv.MMC_Init_Status & (1<<MMCINIT_SD2)) != 0) Tx += "v2";
	    if ((m_YogaDrumsRcv.MMC_Init_Status & (1<<MMCINIT_HC)) != 0) Tx += " HC";    
	  }
	  else
	  if ((m_YogaDrumsRcv.MMC_Init_Status & (1<<MMCINIT_INITOK)) != 0)  
  	  {
	    if (m_YogaDrumsRcv.MMCWriteCmdResp != 0)
	    {
	      Tx += String.format(locale, "ОШИБКА начала записи на SD (0x%x)", m_YogaDrumsRcv.MMCWriteCmdResp);
	    }
	    else
	    {
	      Tx += String.format(locale, "ОШИБКА записи на SD (0x%x)", m_YogaDrumsRcv.MMCWriteRespToken);
	    };
	  }
	  else Tx += "SD-карта ОТСУТСТВУЕТ";
	  Tx += "\n";
	
	  Tx += String.format(locale, "Время %.1f сек, ", m_YogaDrumsRcv.SysTime/2.5e6*256);
	  
	  if (!m_IsNew115200)
	  {
	    String strdate = m_YogaDrumsRcv.GetStartDate();
	    Tx += strdate + "\n";
	  
	    String OldDate = FileDateCache(null);
		if (OldDate.length() < 1)
		{
		  FileDateCache(strdate);	 
		};
	  }
	  else
	  {
		String strdate = m_YogaDrumsRcv.GetRTCDate();
		Tx += strdate + "\n";		  
	  };
	  
	  if (!m_IsNew115200)
	    Tx += String.format(locale, "ФАЙЛ=0x%x, ПОЗ=0x%x, показ %.3fc\n", m_YogaDrumsRcv.FileStartAdr, m_YogaDrumsRcv.OldFile_StartAdr, m_Graph.m_ShowN / 976.5625);
	    else
    	Tx += String.format(locale, "ФАЙЛ=0x%x, Kbrd=%d, показ %.3fc\n", m_YogaDrumsRcv.FileStartAdr, m_YogaDrumsRcv.TH_Config, m_Graph.m_ShowN / 976.5625);

	  if (!m_IsNew115200)
	  {
	    double AX = ((double)m_YogaDrumsRcv.XOut) / m_YogaDrumsRcv.XYZN - 128; 
	    double AY = ((double)m_YogaDrumsRcv.YOut) / m_YogaDrumsRcv.XYZN - 128; 
	    double AZ = ((double)m_YogaDrumsRcv.ZOut) / m_YogaDrumsRcv.XYZN - 128;
	    Tx += String.format(locale, "Уск. X=%.1f, Y=%.1f, Z=%.1f", AX, AY, AZ);
	  }
	  else
	  {
		Tx += String.format(locale, "Уск. X=%d, Y=%d, Z=%d", m_YogaDrumsRcv.m_Mpu6050s[0], m_YogaDrumsRcv.m_Mpu6050s[1], m_YogaDrumsRcv.m_Mpu6050s[2]);  
	  };
	  
	  Tx += String.format(locale, "\nСКО %.1f, размах: %d (от %d до %d), МО %.1f", m_Graph.m_SKO, m_Graph.m_Max-m_Graph.m_Min, m_Graph.m_Min, m_Graph.m_Max, m_Graph.m_MO);
	  
      m_BumTx.setText(Tx);
	};
	  
	 
	 
	 



    public Runnable m_Run = new Runnable()
    {
    	private final int m_NR = 2;
    	private final int m_RSz = 65536;
    	private int m_RPos = 0;

    	private UsbRequest [] m_UsbRRRs = new UsbRequest[m_NR];
    	private ByteBuffer[] m_UsbBuffers = new ByteBuffer[m_NR];
    	
    	public void run()
    	{
    	  m_ThreadsN++;
    	  for (int i=0; i<m_NR; i++) 
    	  {
    		m_UsbRRRs[i] = new UsbRequest();
    	    //m_UsbBuffers[i] = ByteBuffer.allocate(m_RSz);
    	    m_UsbBuffers[i] = ByteBuffer.allocateDirect(m_RSz);
    	  };
    		  
    	  for (int i=0; i<m_NR; i++)
          {
        	boolean Is1 = m_UsbRRRs[i].initialize(m_UsbConn, m_UsbEP_In);
        	if (!Is1) { m_ThreadsN--; return; };        	
          };
          
          for (int i=0; i<m_NR; i++)
          {
        	m_UsbBuffers[i].position(0);
        	boolean Is2 = m_UsbRRRs[i].queue(m_UsbBuffers[i], m_RSz);
        	if (!Is2) { m_ThreadsN--; return; };
          };
          
          m_RPos = 0;
          
          while (true) //for (int j=0; j<m_NR; j++)
          {
        	  UsbRequest rrr = m_UsbConn.requestWait();
      		  if (rrr == null) break;
      		  if (rrr != m_UsbRRRs[m_RPos]) break;
      		  final int EndPos = m_UsbBuffers[m_RPos].position();
      		  if (m_MaxRd < EndPos) m_MaxRd = EndPos;
      		  m_AllRd += EndPos;
      		  m_AllOp++;
      	      
      	      ByteBuffer buf = m_UsbBuffers[m_RPos]; 
      		  
      	      m_YogaDrumsRcv.ProcessDataRcvYogaDrums(buf, EndPos);
      	      
      	      buf.position(0);
        	  boolean Is3 = m_UsbRRRs[m_RPos].queue(m_UsbBuffers[m_RPos], m_RSz);
        	  if (!Is3) break;
        	  
        	  m_RPos++;
        	  if (m_RPos>=m_NR) m_RPos = 0;      		  
          };    
          
          m_ThreadsN--;          
  		};
  		  

    };
    
    private String FileDateCache(String sNewDate)
    {
      Locale locale = Locale.getDefault();		
	  String skey = String.format(locale, "SDFile_%x", m_YogaDrumsRcv.FileStartAdr);
	  SharedPreferences sPref = getSharedPreferences("SDFilesDateCache", MODE_PRIVATE); //getPreferences(MODE_PRIVATE);
      String savedText = sPref.getString(skey, "");      
      if (sNewDate != null)
      {
        Editor ed = sPref.edit();
        ed.putString(skey, sNewDate);
        ed.commit();
      };      
      return savedText;
    };
    
    public boolean onTouch(View v, MotionEvent event) 
    {
      float x = event.getX();
      float y = event.getY();
       
      switch (event.getAction()) 
      {
      case MotionEvent.ACTION_DOWN: // нажатие
        MyTx.setText("Down: " + x + ",  " + y);
        break;
      case MotionEvent.ACTION_MOVE: // движение
    	  MyTx.setText("move: " + x + ",  " + y);
          break;
      case MotionEvent.ACTION_UP: // отпускание
      case MotionEvent.ACTION_CANCEL:  
    	  MyTx.setText("Up: " + x + ",  " + y);
          break;
      }
      return true;
    }
    
    // Номера битов переменной MMC_Init_Status (копия из Pic asm-кода)
    
    private static final int MMCINIT_SD2 =  0;     // установлен, если версия спецификации SD >= 2.0
    private static final int MMCINIT_HC  =  1;     // установлен, если SD HC
    private static final int MMCINIT_INITOK =   2; // установлен, если инициализация SD проведена успешно
    private static final int MMCINIT_CANWRITE = 3; // установлен, если SD готова к записи блоков данных

}
