﻿package ru.zvzd3d.EKG.NikyEkgSD1;

import android.content.Context;
import android.util.AttributeSet;
import android.view.View;
import android.view.ViewGroup;

public class ONikyFlowLayout extends ViewGroup   
{
    public ONikyFlowLayout(Context context) 
    {
        super(context);
    }

    public ONikyFlowLayout(Context context, AttributeSet attrs) 
    {
        this(context, attrs, 0);
    }

    public ONikyFlowLayout(Context context, AttributeSet attrs, int defStyle) 
    {
        super(context, attrs, defStyle);
    }
    
    private int mHeight;
    
    private int PAD_V = 4;
    private int PAD_H = 4;
    
    /**
     * Any layout manager that doesn't scroll will want this.
     */
    @Override
    public boolean shouldDelayChildPressedState() 
    {
        return false;
    }    


    @Override
    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) 
    {
        final int width = MeasureSpec.getSize(widthMeasureSpec) - getPaddingLeft() - getPaddingRight();
        int height = MeasureSpec.getSize(heightMeasureSpec) - getPaddingTop() - getPaddingBottom();
        int xpos = getPaddingLeft();
        int ypos = getPaddingTop();
        int childHeightMeasureSpec;
        if(MeasureSpec.getMode(heightMeasureSpec) == MeasureSpec.AT_MOST)
            childHeightMeasureSpec = MeasureSpec.makeMeasureSpec(height, MeasureSpec.AT_MOST);
            else
            childHeightMeasureSpec = MeasureSpec.makeMeasureSpec(0, MeasureSpec.UNSPECIFIED);
        mHeight = 0;
        final int count = getChildCount();
        for(int i = 0; i < count; i++) 
        {
            final View child = getChildAt(i);
            if(child.getVisibility() == GONE) continue; 
            child.measure(MeasureSpec.makeMeasureSpec(width, MeasureSpec.AT_MOST), childHeightMeasureSpec);
            //measureChildWithMargins(child, widthMeasureSpec, 0, heightMeasureSpec, 0); // !!!

            final int childw = child.getMeasuredWidth();
            mHeight = Math.max(mHeight, child.getMeasuredHeight() + PAD_V);
            if(xpos + childw > width) 
            {
                    xpos = getPaddingLeft();
                    ypos += mHeight; 
            }
            xpos += childw + PAD_H;            
        }
        if(MeasureSpec.getMode(heightMeasureSpec) == MeasureSpec.UNSPECIFIED) 
        {
            height = ypos + mHeight;
        } 
        else 
        if(MeasureSpec.getMode(heightMeasureSpec) == MeasureSpec.AT_MOST) 
        {
            if(ypos + mHeight < height) { height = ypos + mHeight; }
        }
        height += 5; // Fudge to avoid clipping bottom of last row.
        setMeasuredDimension(width, height);
    } 

    @Override
    protected void onLayout(boolean changed, int l, int t, int r, int b) 
    {
        final int width = r - l;
        int xpos = getPaddingLeft();
        int ypos = getPaddingTop();
        for(int i = 0; i < getChildCount(); i++) 
        {
            final View child = getChildAt(i);
            if(child.getVisibility() == GONE) continue;
            
            final int childw = child.getMeasuredWidth();
            final int childh = child.getMeasuredHeight();
            if(xpos + childw > width) 
            {
                    xpos = getPaddingLeft();
                    ypos += mHeight;
            }
            child.layout(xpos, ypos, xpos + childw, ypos + childh);
            xpos += childw + PAD_H;
        }
    } 

};
