﻿package ru.zvzd3d.EKG.NikyEkgSD1;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Paint.Style;
import android.graphics.Path;
import android.graphics.Rect;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

public class ONikyGraph extends View 
{
	public TextView MyTx = null;
	private Paint m_paint = null;
	
	public final int m_MaxLen = 6000;
	
	public int m_ChsN = 2;
	
	public int m_Data[] = new int[m_MaxLen];
	public int m_Data2[] = new int[m_MaxLen];
	public int m_Data3[] = new int[m_MaxLen];
	public int m_ShowN = 3000;
	public int m_DataPos = 3000;
	
	public String m_Str1 = null;
	public String m_Str2 = null;
    public String m_Str3 = null;
    private Rect m_RTx = new Rect();
    
	
	private boolean m_IsCap = false;
	private float m_CapY = 0;
	private float m_CapX = 0;
	private float m_CapShowN = 0;
	
	
	private Path m_path = new Path();
	
	public boolean m_IsUpdateGraph = true;
	
	public ONikyGraph(Context context, AttributeSet attrs) 
	{
        super(context, attrs);
        m_paint = new Paint();
        
        for (int i=0; i<m_MaxLen; i++)
        {
          int V = (int) (3333 + 2*Math.cos(i*6.28*10/m_MaxLen)*Math.exp(-3.0*i/m_MaxLen));
          m_Data[i] = V; 
          m_Data2[i] = -V*20;
        };
    };
    
	@Override
	protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) 
	{
		//if (MeasureSpec.getMode(heightMeasureSpec) == MeasureSpec.UNSPECIFIED && getLayoutParams().height > 0) 
		//{
		//  heightMeasureSpec = MeasureSpec.makeMeasureSpec(getLayoutParams().height, MeasureSpec.EXACTLY);
		//}
		
		//final int height = getMeasuredHeight();	// высота
		//final int width = getMeasuredWidth();	// ширина
		
		//MyTx.append("\n" + " MS = " + MeasureSpec.getMode(heightMeasureSpec) + " w=" + widthMeasureSpec + " h=" + heightMeasureSpec);
		
		if (heightMeasureSpec <= 0) 
		{
          if (m_IsUpdateGraph)
			heightMeasureSpec = 1 + widthMeasureSpec/2;
            else
            heightMeasureSpec = 50;
		};
 
		setMeasuredDimension(widthMeasureSpec, heightMeasureSpec);
		
		m_paint.setTextSize(35.0f);
	};
    
    @Override
    protected void onDraw(Canvas canvas) 
    {
    	m_paint.setStyle(Style.STROKE);
        m_paint.setColor(0xFFFF0000);
        m_paint.setStrokeWidth(3);
        //canvas.drawLine(0, 0, getWidth(), getHeight(), m_paint);
        //canvas.drawPath()
        final int CX = getWidth();
        final int CY = getHeight();
        
        final int ShowN = m_ShowN;
        
        int pos0 = m_DataPos - ShowN;
        while (pos0<0) pos0 += m_MaxLen;
        		
        int Min = 1000000;
        int Max = -Min;
        int pos = pos0;
        for (int i=0; i<ShowN; i++)
        {
          if (Min > m_Data[pos]) Min = m_Data[pos];
          if (Max < m_Data[pos]) Max = m_Data[pos];
          pos++; if (pos >= m_MaxLen) pos = 0;	
        };        
        if (Max-Min<4)
        {
          int Ss = (Max+Min)/2;
          Max = Ss + 2;
          Min = Ss - 2;
        };
        
        int Min2 = 1000000;
        int Max2 = -Min2;
        if (m_ChsN >= 2)
        {
        	pos = pos0;
            for (int i=0; i<ShowN; i++)
            {
              if (Min2 > m_Data2[pos]) Min2 = m_Data2[pos];
              if (Max2 < m_Data2[pos]) Max2 = m_Data2[pos];
              pos++; if (pos >= m_MaxLen) pos = 0;	
            };        
            if (Max2-Min2<4)
            {
              int Ss = (Max2+Min2)/2;
              Max2 = Ss + 2;
              Min2 = Ss - 2;
            };            	
        };
        
        int Min3 = 1000000;
        int Max3 = -Min3;
        if (m_ChsN >= 3)
        {
        	pos = pos0;
            for (int i=0; i<ShowN; i++)
            {
              if (Min2 > m_Data3[pos]) Min3 = m_Data3[pos];
              if (Max2 < m_Data3[pos]) Max3 = m_Data3[pos];
              pos++; if (pos >= m_MaxLen) pos = 0;	
            };        
            if (Max3-Min3<4)
            {
              int Ss = (Max3+Min3)/2;
              Max3 = Ss + 2;
              Min3 = Ss - 2;
            };            	
        };
        
        final float XStep = ((float)CX)/ShowN;
        final int CY2 = (CY-8);
        
        for (int igr=0; igr<m_ChsN; igr++)
        {
            if (igr == 1) { Max=Max2; Min=Min2; };
            if (igr == 2) { Max=Max3; Min=Min3; };
        	float YStep = ((float)(CY2-2)) / (Max-Min) / m_ChsN;
            float CY22 = CY2*(igr+1)/m_ChsN;
	        
	        m_paint.setColor(0xFF00C000);
	    	m_path.reset();
	    	pos = pos0;
	    	
	    	int pD[] = m_Data; 
	    	if (igr == 1) pD = m_Data2;
	    	if (igr == 2) pD = m_Data3;
	        for (int i=0; i<ShowN; i++)
	        {
	          float x = i * XStep;          
	          float y = CY22 - (pD[pos] - Min) * YStep;
	          pos++; if (pos >= m_MaxLen) pos = 0;
	          
	          if (i == 0)
	          {
	        	m_path.reset(); 
	        	m_path.moveTo(x, y);                    	
	          };
	          m_path.lineTo(x, y);          
	        };
	        canvas.drawPath(m_path, m_paint);
        };
        
        float x0 = 0;
        float x1 = CX;
        float y0 = CY-7;
        float y1 = CY; 
        m_paint.setStyle(Paint.Style.FILL);    	
        m_paint.setColor(0xFFC0C0C0);
        canvas.drawRect(x0,y0, x1, y0+1, m_paint);
        m_paint.setColor(0xFFFFFFFF);
        canvas.drawRect(x0,y0+1, x1, y0+2, m_paint);
        m_paint.setColor(0xFFC0C0C0);
        if (m_IsCap) m_paint.setColor(0xFFF0F0C0);
        canvas.drawRect(x0,y0+2, x1, y1-2, m_paint);
        m_paint.setColor(0xFF808080);
        canvas.drawRect(x0,y1-2, x1, y1-1, m_paint);
        m_paint.setColor(0xFF000000);
        canvas.drawRect(x0,y1-1, x1, y1, m_paint);
        
        int TxY0 = 0;
        for (int ii=0; ii<3; ii++)
        {
          String s = m_Str1;
          if (ii == 1) s = m_Str2;
          if (ii == 2) s = m_Str3;
          if (s == null) continue;
          
          m_paint.getTextBounds(s, 0, s.length(), m_RTx);
          int x = CX - m_RTx.width();
          if (x<0) x = 0;
          
          TxY0 += m_RTx.height() + 2;
          canvas.drawText(s, x, TxY0, m_paint);
        };
    };
    
    public double m_MO = -1;
    public double m_SKO = -2;
    public int m_Min = -3;
    public int m_Max = -73;
    
    public void AnalizeSignal() 
    {
        final int ShowN = m_ShowN;
    
        int pos0 = m_DataPos - ShowN;
        while (pos0<0) pos0 += m_MaxLen;
        		
        int Min = 1000000;
        int Max = -Min;
        int pos = pos0;
        double s = 0;
        double d = 0;
        for (int i=0; i<ShowN; i++)
        {
          if (Min > m_Data[pos]) Min = m_Data[pos];
          if (Max < m_Data[pos]) Max = m_Data[pos];
          s += m_Data[pos];
          d += m_Data[pos] * m_Data[pos];
          pos++; if (pos >= m_MaxLen) pos = 0;	
        };        
        
        s /= ShowN;
        d /= ShowN;
        d -= s*s;
        d = Math.sqrt(d);
        
        m_MO = s;
        m_SKO = d;
        m_Min = Min;
        m_Max = Max;        
    };
    
    
    //@Override
    public boolean onInterceptTouchEvent(MotionEvent ev) 
    {
        return onTouchEvent(ev);
      //  return true;
    	//return super.onInterceptTouchEvent(ev);
    }

    //@Override
    public boolean onTouchEvent(MotionEvent event) 
    {
        //Toast.makeText(this.getContext(), "Touched layout", Toast.LENGTH_SHORT).show();
        //Log.d("TOUCH", "Touched layout");
    	if (event.getAction() == 0) 
    	{
    	  if (event.getY() >= getHeight()*0.9-17) m_IsCap = true;
    	  m_CapX = event.getX();
    	  m_CapY = event.getY();
    	  m_CapShowN = m_ShowN;
    	  if (m_IsCap) getParent().getParent().requestDisallowInterceptTouchEvent(true);
    	  invalidate();
    	};
    	if (event.getAction() == 1) 
    	{
    	  m_IsCap = false;
    	  if (!m_IsCap) getParent().getParent().requestDisallowInterceptTouchEvent(false);
    	  
    	  int NewSz = (int)(getHeight() + event.getY() - m_CapY);
    	  //getLayoutParams().height = NewSz;
    	  LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(getWidth(), NewSz); 
    	  //LinearLayout.LayoutParams layoutParams = getLayoutParams();
    	  //layoutParams.height = NewSz;
    	  setLayoutParams(layoutParams); 
    	  requestLayout();
    	  invalidate();
    	  //MyTx.setText("NewSz = " + NewSz);
    	  return true;
    	};
    	
    	if (event.getAction() == 2 && m_IsCap) 
    	{
    		float x = getWidth() - event.getX();
    		//m_ShowN -= (int)(x - m_CapX);
    		//m_CapX = x;
    		if (x<10) x = 10;
    		
    		float ShowN = m_CapShowN * (getWidth()-m_CapX) / x; 
    		
    		if (ShowN<80) ShowN = 80;
    		if (ShowN>m_MaxLen) ShowN = m_MaxLen;
    		m_ShowN = (int) ShowN;
    		invalidate();
    	};
    	//MyTx.setText("onTouchEvent = " + event.getAction() + ", x=" + event.getX() + ", Y=" + event.getY() + ", IsCap=" + m_IsCap + " W=" + getHeight());
        return true;
    } 
};
