package ru.zvzd3d.EKG.NikyEkgSD1;

import android.hardware.usb.UsbConstants;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbEndpoint;
import android.hardware.usb.UsbInterface;


public class OUsbComCP2102 
{
	public UsbEndpoint m_EP_In = null;   //   FindDataEPs
	public UsbEndpoint m_EP_Out = null;
	
	public OUsbComCP2102() 
	{
    };
	
	public static boolean IsMyDevice(UsbDevice device)
	{
		if (device == null) return false;
		if (device.getVendorId() == 0x10C4 && device.getProductId() == 0xEA60) return true;
		if (device.getVendorId() == 0x10C4 && device.getProductId() == 0xEA70) return true;
		
		if (device.getVendorId() == 0x11CA && device.getProductId() == 0x212) return true; //    
		return false;
	};
	
	public boolean FindDataEPs(UsbInterface intf)
	{
	   m_EP_In = null;  m_EP_Out = null;
	   int nf = 0;
	   for (int i=0; i<intf.getEndpointCount(); i++)
       {
    	 UsbEndpoint ep = intf.getEndpoint(i);
    	 if (ep.getType() == UsbConstants.USB_ENDPOINT_XFER_BULK && ep.getDirection() == UsbConstants.USB_DIR_IN)
    	 {
    		m_EP_In = ep;  nf++; 
    	 };
    	 if (ep.getType() == UsbConstants.USB_ENDPOINT_XFER_BULK && ep.getDirection() == UsbConstants.USB_DIR_OUT)
    	 {
    		m_EP_Out = ep;  nf++; 
    	 };
       };
       if (nf != 2 || m_EP_In == null || m_EP_Out == null)
       {
    	 m_EP_In = null;  m_EP_Out = null;
    	 return false;
       };
       return true;
	};
	
	public String Init(UsbDeviceConnection UsbConn, UsbInterface intf, int Speed)
	{
	   boolean Is = cp210x_SendSetup(UsbConn, CP210X_IFC_ENABLE, UART_ENABLE, 0, null);
	   if (!Is)
	   {
    	 return "CP2102:  CP210X_IFC_ENABLE";    	      
       };
       
       byte BufSpeed[] = { (byte) (Speed), (byte) (Speed>>8), (byte) (Speed>>16), (byte) (Speed>>24) };
       Is = cp210x_SendSetup(UsbConn, CP210X_SET_BAUDRATE, 0, 0, BufSpeed);
       if (!Is)
	   {
    	 return "CP2102:  CP210X_SET_BAUDRATE";    	      
       };
       
       //     FLOW, LINE_CTL,   PURGE, 
       //  EMBED_EVENTS           

       // 8 , 1 ,  
       Is = cp210x_SendSetup(UsbConn, CP210X_SET_LINE_CTL, 0x800, 0, null);
       if (!Is)
	   {
    	 return "CP2102:  CP210X_SET_LINE_CTL";    	      
       };
       
       byte Flow[] = new byte[16];
       for (int ii=0; ii<16; ii++) Flow[ii] = 0;
       Is = cp210x_SendSetup(UsbConn, CP210X_SET_FLOW, 0, 0, Flow);
       if (!Is)
	   {
    	 return "CP2102:  CP210X_SET_FLOW";    	      
       };
       
       return "";
	};
	
	private boolean cp210x_SendSetup(UsbDeviceConnection UsbConn, int SetupCode, int Value, int Index, final byte [] buf)
	{
	  int szsend = 0;
	  if (buf != null) szsend = buf.length; 
	  int len = UsbConn.controlTransfer(REQTYPE_HOST_TO_INTERFACE, SetupCode, Value, Index, buf, szsend, 1000);
	  if (len < 0 || len != szsend) return false;
	  return true;
	};

	

	
	// Config request types 
	private static final int REQTYPE_HOST_TO_INTERFACE	= 0x41;
	private static final int REQTYPE_INTERFACE_TO_HOST	= 0xc1;
	private static final int REQTYPE_HOST_TO_DEVICE	= 0x40;
	private static final int REQTYPE_DEVICE_TO_HOST	= 0xc0;

	// Config request codes 
	private static final int CP210X_IFC_ENABLE	= 0x00;
	private static final int CP210X_SET_BAUDDIV	= 0x01;
	private static final int CP210X_GET_BAUDDIV	= 0x02;
	private static final int CP210X_SET_LINE_CTL	= 0x03;
	private static final int CP210X_GET_LINE_CTL	= 0x04;
	private static final int CP210X_SET_BREAK	= 0x05;
	private static final int CP210X_IMM_CHAR	= 0x06;
	private static final int CP210X_SET_MHS		= 0x07;
	private static final int CP210X_GET_MDMSTS	= 0x08;
	private static final int CP210X_SET_XON		= 0x09;
	private static final int CP210X_SET_XOFF		= 0x0A;
	private static final int CP210X_SET_EVENTMASK	= 0x0B;
	private static final int CP210X_GET_EVENTMASK	= 0x0C;
	private static final int CP210X_SET_CHAR		= 0x0D;
	private static final int CP210X_GET_CHARS	= 0x0E;
	private static final int CP210X_GET_PROPS	= 0x0F;
	private static final int CP210X_GET_COMM_STATUS	= 0x10;
	private static final int CP210X_RESET		= 0x11;
	private static final int CP210X_PURGE		= 0x12;
	private static final int CP210X_SET_FLOW		= 0x13;
	private static final int CP210X_GET_FLOW		= 0x14;
	private static final int CP210X_EMBED_EVENTS	= 0x15;
	private static final int CP210X_GET_EVENTSTATE	= 0x16;
	private static final int CP210X_SET_CHARS	    = 0x19;
	private static final int CP210X_GET_BAUDRATE	= 0x1D;
	private static final int CP210X_SET_BAUDRATE	= 0x1E;
	private static final int CP210X_VENDOR_SPECIFIC	= 0xFF;

	// CP210X_IFC_ENABLE 
	private static final int UART_ENABLE		= 0x0001;
	private static final int UART_DISABLE		= 0x0000; 


}
