package ru.zvzd3d.EKG.NikyEkgSD1;

//import android.content.Context;
import android.hardware.usb.UsbConstants;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbEndpoint;
import android.hardware.usb.UsbInterface;
//import android.hardware.usb.UsbManager;
//import android.hardware.usb.UsbRequest;
//import android.util.AttributeSet;

public class OUsbComPL203 
{
	public UsbEndpoint m_EP_In = null;   // FindDataEPs
	public UsbEndpoint m_EP_Out = null;
	
	public OUsbComPL203() 
	{
    };
	
	public static boolean IsMyDevice(UsbDevice device)
	{
		if (device == null) return false;
		if (device.getVendorId() == 0x067B && device.getProductId() == 0x2303) return true;
		return false;
	};
	
	public boolean FindDataEPs(UsbInterface intf)
	{
	   m_EP_In = null;  m_EP_Out = null;
	   int nf = 0;
	   for (int i=0; i<intf.getEndpointCount(); i++)
       {
    	 UsbEndpoint ep = intf.getEndpoint(i);
    	 if (ep.getType() == UsbConstants.USB_ENDPOINT_XFER_BULK && ep.getDirection() == UsbConstants.USB_DIR_IN)
    	 {
    		m_EP_In = ep;  nf++; 
    	 };
    	 if (ep.getType() == UsbConstants.USB_ENDPOINT_XFER_BULK && ep.getDirection() == UsbConstants.USB_DIR_OUT)
    	 {
    		m_EP_Out = ep;  nf++; 
    	 };
       };
       if (nf != 2 || m_EP_In == null || m_EP_Out == null)
       {
    	 m_EP_In = null;  m_EP_Out = null;
    	 return false;
       };
       return true;
	};
	
	public String Init(UsbDeviceConnection UsbConn, UsbInterface intf, int Speed)
	{
	   int tp = TYPE_01;
	   
	   //byte RawDesc[] = UsbConn.getRawDescriptors(); 
	   int bMaxPacketSize0 = 64; //RawDesc[7];
	   
	   if (intf.getInterfaceClass() == 0x02) tp = TYPE_01;
	   else
	   if (bMaxPacketSize0 == 64) tp = TYPE_HX;
	   
	   if (tp == TYPE_01) return "PL2303: cлишком старая, не поддерживаю";
	   
	   byte buf[] = new byte[256];
	   int dataLength = buf.length;
	   int len = UsbConn.controlTransfer(VENDOR_READ_REQUEST_TYPE, VENDOR_READ_REQUEST, PL2303_READ_TYPE_HX_STATUS, 0, buf, dataLength, 1000);
       if (len < 0) 
       {
    	 return "PL2303: cлишком новая, не поддерживаю";    	      
       };
       
       m_UsbConn = UsbConn;
       m_IsSendError = 0;
       
       if (tp != TYPE_HXN)  // когда производитель козёл
       {
         pl2303_vendor_read(0x8484, buf);
  	     pl2303_vendor_write(0x0404, 0);
  	     pl2303_vendor_read(0x8484, buf);
  	     pl2303_vendor_read(0x8383, buf);
  	     pl2303_vendor_read(0x8484, buf);
  	     pl2303_vendor_write(0x0404, 1);
  	     pl2303_vendor_read(0x8484, buf);
  	     pl2303_vendor_read(0x8383, buf);
  	     pl2303_vendor_write(0, 1);
  	     pl2303_vendor_write(1, 0);
  	     if (tp == TYPE_01) pl2303_vendor_write(2, 0x24); else  pl2303_vendor_write(2, 0x44);

	     if (m_IsSendError != 0)
	     {
	        m_UsbConn = null;
	        return "PL2303: ошибка при хитрой иниц."; 	         	 
	     };
       };
       
       // из pl2303_open() и соответственно исходника на java
       pl2303_vendor_write(8, 0);
       pl2303_vendor_write(9, 0);
       
       if (m_IsSendError != 0)
	   {
	      m_UsbConn = null;
	      return "PL2303: ошибка при иниц."; 	         	 
	   };
	   
	   m_UsbConn = null; m_IsSendError = 7777;
       
       len = UsbConn.controlTransfer(SET_CONTROL_REQUEST_TYPE, SET_CONTROL_REQUEST, CONTROL_DTR | CONTROL_RTS, 0, null, 0, 1000);
       if (len < 0) 
       {
    	 return "PL2303: ошибка SET_CONTROL_REQUEST";    	      
       };
       
       byte defaultSetLine[] = new byte [] 
 { (byte) (Speed), // [0:3] Baud rate (reverse hex encoding 9600:00 00 25 80 -> 80 25 00 00)
   (byte) (Speed>>8), (byte) (Speed>>16), (byte) (Speed>>24),
   (byte)0x00, // [4] Stop Bits (0=1, 1=1.5, 2=2)
   (byte)0x00, // [5] Parity (0=NONE 1=ODD 2=EVEN 3=MARK 4=SPACE)
   (byte)0x08  // [6] Data Bits (5=5, 6=6, 7=7, 8=8) 
 };
       len = UsbConn.controlTransfer(SET_LINE_REQUEST_TYPE, SET_LINE_REQUEST, 0, 0, defaultSetLine, defaultSetLine.length, 1000);
       if (len < 0) 
       {
    	 return "PL2303: ошибка SET_LINE_REQUEST";    	      
       };
       
       // Считаем, что FLOW по умолчанию ноль и не настраиваем 
	   return "";
	};
	
	private UsbDeviceConnection m_UsbConn = null;
	private int m_IsSendError = 0;
	
	private void pl2303_vendor_read(int Value, byte [] buf)
	{
	  if (m_IsSendError != 0) return;
	  int request = VENDOR_READ_REQUEST;
	  //if (m_tp == TYPE_HXN) request = VENDOR_READ_NREQUEST;  
   
	  int dataLength = buf.length;
	  int len = m_UsbConn.controlTransfer(VENDOR_READ_REQUEST_TYPE, request, Value, 0, buf, dataLength, 1000);
	  if (len < 0) m_IsSendError++;
	};

	private void pl2303_vendor_write(int Value, int Index)
	{
	  if (m_IsSendError != 0) return;
	  int request = VENDOR_WRITE_REQUEST;
	  //if (m_tp == TYPE_HXN) request = VENDOR_WRITE_NREQUEST;
	  
	  int len = m_UsbConn.controlTransfer(VENDOR_WRITE_REQUEST_TYPE, request, Value, Index, null, 0, 1000);
	  if (len < 0) m_IsSendError++;
	};

	
	private static final int TYPE_01 = (0);	    // Type 0 and 1 (difference unknown) 
	private static final int TYPE_HX = (1);     // HX version of the pl2303 chip 
	private static final int TYPE_HXN = (2); 	// HXN version of the pl2303 chip  

	private static final int VENDOR_WRITE_REQUEST_TYPE	= 0x40;
	private static final int VENDOR_READ_REQUEST_TYPE	= 0xc0;

	private static final int VENDOR_READ_REQUEST		= 0x01;
	private static final int VENDOR_WRITE_REQUEST		= 0x01;

	private static final int VENDOR_READ_NREQUEST		= 0x81; //  для HXN
	private static final int VENDOR_WRITE_NREQUEST		= 0x80;


	private static final int PL2303_READ_TYPE_HX_STATUS	= 0x8080; // для HX, в отличии от HXN


	private static final int SET_LINE_REQUEST_TYPE	  	= 0x21;  // типы запросов одинаковые
	private static final int SET_CONTROL_REQUEST_TYPE	= 0x21;
	private static final int BREAK_REQUEST_TYPE		    = 0x21;

	private static final int SET_LINE_REQUEST		    = 0x20;  // разные запросы
	private static final int SET_CONTROL_REQUEST		= 0x22;
	private static final int BREAK_REQUEST			    = 0x23;

	private static final int CONTROL_DTR			= 0x01;
	private static final int CONTROL_RTS			= 0x02;
	private static final int BREAK_ON			= 0xffff;
	private static final int BREAK_OFF			= 0x0000;

	private static final int PL2303_FLOWCTRL_MASK	=	0xf0;



};
